// DC[^xvO

#include	<xc.h>

#pragma config FOSC = INTOSC    // IV[^ ICRA5NbN͗pł͂ȂC I/Opɐݒ
#pragma config WDTE = OFF       // EHb`hbO^C} It
#pragma config PWRTE = OFF      // pAbv^C} It
#pragma config MCLRE = ON       // 4ԃsMCLRpɐݒ
#pragma config CP = OFF         // R[hی It
#pragma config CPD = OFF        // f[^R[hی It
#pragma config BOREN = OFF      // dZbg It
#pragma config CLKOUTEN = OFF	// NbNMo̓si3ԃsj It
#pragma config IESO = OFF       // dグ̓IV[^  OIV[^ؑ It
#pragma config FCMEN = OFF      // tFCZ[tNbNj^ It
#pragma config WRT = OFF        // tbVݕی It
#pragma config PLLEN = ON       // PLL I
#pragma config STVREN = OFF     // X^bNI[o[^A_[t[Zbg It
#pragma config BORV = HI        // dZbg̐ݒd2.7[V]ɐݒD(LOW=1.9 [V])
#pragma config LVP = ON         // diႦ3.3 [V]jł̃vO~O I (SnapLVP ON ł̂݃vO~O\)

#define _XTAL_FREQ 32000000

#define Kp		32              // QC 
#define Kidt	 1              //@ϕQC 

signed int w_com;				//]wߒl
signed int w_det;				//]ol
signed int w_diff;				//]
signed int v_com;				//dwߒl
signed int w_diff_integ = 0;	//ϕ

static void __interrupt()		// Timer1 ɂ銄荞ݏ[`
timer1_isr(void)
{
	RC1 = 1;                    // |[gCRC11o͂D荞ݔ̃j^Op

	TMR1 = 0x8330;              // ^C}1̃JEgAbvl̐ݒD
                                // ͒llƂăJEgAbvsCI[o[t[Ŋ荞݂𔭐
	PIR1bits.TMR1IF = 0;        // ^C}1̊荞݃tO0ɂāC̃^C}1ɂ銄荞݂tƂ

	ADCON0bits.CHS = 0b00110;	// AiO`lAN6(8ԃsjɐݒ
	__delay_us(5);				// `l؂ւA/DRo[^͓̓d肷܂ł̑҂(p.160)
	ADCON0bits.GO = 0b1;		// A/DRo[^̕ϊJn(p.156)
	while(ADCON0bits.GO);		// ϊI҂	
	w_com = ADRES;				// ]wߒl̓ǂݏo

	ADCON0bits.CHS = 0b00100;	// AiO`lAN4(10ԃsjɐݒ
	__delay_us(5);				// `l؂ւA/DRo[^͓̓d肷܂ł̑҂(p.160)
	ADCON0bits.GO = 0b1;		// A/DRo[^̕ϊJn(p.156)
	while(ADCON0bits.GO);		// ϊI҂	
	w_det = ADRES;				// ]ol̓ǂݏo

	w_diff = w_com - w_det;		// ]̍
	w_diff_integ += w_diff;		// ϕ

	if(w_diff_integ >= 1023)	//@~b^@@0<= w_diff_integ <= 1023
	{
		w_diff_integ = 1023;
	} else if(w_diff_integ < 0)
	{
		w_diff_integ = 0;
	}

	v_com = Kp * w_diff  + Kidt * w_diff_integ + 512;  // PIo͂̌vZ

	if(v_com >= 1023)			// ~b^@@@0<= w_com <= 1023
	{
		v_com = 1023;
	} else if(v_com < 0)
	{
		v_com = 0;
	}

	CCP2CONbits.DC2B = v_com  & 0b00000011; 	// DC2B ɓdwߒl̉2rbgi[D
	CCPR2L = v_com >>2;			 				// CCPR2L ɓdwߒl̏8rbgi[D

	RC1 = 0;                    // |[gCRC10o͂D荞ݔ̃j^Op
}

void main(void)
{
	TRISA = 0x00;               // |[gAo̓|[gɐݒ肷D
	TRISC = 0x05;               // |[gC0, 2̓|[gɐݒ肷D

	//IV[^̐ݒ
	OSCCONbits.IRCF = 0b1110;	// IV[^̊e핪NbN̒8MHzI
	OSCCONbits.SCS =  0b00;		// NbN\[X̓RtBM[Vݒɏ]D
                                // RtBM[Vł8MHz+4{PLL = 32MHz̐ݒ

	// ^C}1̐ݒ
	T1CONbits.TMR1CS = 0b01;	// ^C}1̃NbN\[XVXeNbN(FOSC)ɐݒ
	T1CONbits.T1CKPS = 0b00;	// ^C}1̃NbN1:1ɐݒiȂj
	T1CONbits.TMR1ON = 0b1;		// ^C}1IƂD

	// ^C}1ɂ銄荞ݐݒ
	PIE1bits.TMR1IE = 1;		// ^C}1ɂ銄荞݉ƂD
	INTCONbits.PEIE = 1;		// ^C}1Ȃǂ̎ӃW[ɂ銄荞݂ƂD
	INTCONbits.GIE = 1;			// SĂ̊荞݂ƂD

	// A/DϊW[̐ݒ
	ADCON0bits.ADON = 0b1;		// A/DRo[^IƂD
	ADCON1bits.ADFM = 0b1;		// ϊʂ16rbgWX^̉10rbgɓD
	ADCON1bits.ADCS = 0b010;	// A/DRo[^̃NbNFOSC/32ɐݒil)
	ADCON1bits.ADNREF = 0b0;	// d́|VSSƂD
	ADCON1bits.ADPREF = 0b11;	// d́{FVR(Fixed Voltage Ref.)ƂD
	
	// A/DRo[^̊d(FVR: Fixed Voltage Reference)̐ݒ
	FVRCONbits.FVREN = 0b1;		// FVRIƂD
	FVRCONbits.ADFVR = 0b11;	// A/DRo[^̊d4.096 [V]ɐݒ

	//PWMW[̐ݒ
	CCP2CONbits.P2M = 0b10;		// Half Bridge, P2A, P2B𗘗pD@P2C, P2D̓|[gs
	CCP2CONbits.CCP2M = 0b1100;	// PWM[h@P2A, P2B 𐳘_ƂD

	// PWMo̓s̊蓖
	APFCON1bits.P2BSEL = 0b1;	// P2BRA4(3ԃs)Ɋ蓖Ă.
	APFCON1bits.CCP2SEL = 0b1;	// P2ARA5(2ԃsjɊ蓖ĂD

	// PWMp̃^C}̊蓖
	CCPTMRSbits.C2TSEL = 0b00;	// PWMp̃^C}Ƃă^C}2蓖ĂD

	// ^C}2̐ݒ
	T2CONbits.T2OUTPS = 0b000;	// ^C}2o͂̕1:1ɐݒiȂj
	T2CONbits.TMR2ON = 0b1;		// ^C}2IƂD
	T2CONbits.T2CKPS = 0b00;	// ^C}2̓̓NbN(FOSC/4)1:1ɕD
	PR2 = 0xFF;					// PWMgݒ@FOSC/4/256 = 32[MHz]/4/256 = 31.25[kHz]


	for(;;)
		continue;		// [v
}
