// PWMvO

#include	<xc.h>
#include	".\PIC16F1825_Files\pic16f1825_s.h"

#pragma config FOSC = INTOSC    // IV[^ ICRA5NbN͗pł͂ȂC I/Opɐݒ
#pragma config WDTE = OFF       // EHb`hbO^C} It
#pragma config PWRTE = OFF      // pAbv^C} It
#pragma config MCLRE = ON       // 4ԃsMCLRpɐݒ
#pragma config CP = OFF         // R[hی It
#pragma config CPD = OFF        // f[^R[hی It
#pragma config BOREN = OFF      // dZbg It
#pragma config CLKOUTEN = OFF	// NbNMo̓si3ԃsj It
#pragma config IESO = OFF       // dグ̓IV[^  OIV[^ؑ It
#pragma config FCMEN = OFF      // tFCZ[tNbNj^ It
#pragma config WRT = OFF        // tbVݕی It
#pragma config PLLEN = ON       // PLL I
#pragma config STVREN = OFF     // X^bNI[o[^A_[t[Zbg It
#pragma config BORV = HI        // dZbg̐ݒd2.7[V]ɐݒD(LOW=1.9 [V])
#pragma config LVP = ON         // diႦ3.3 [V]jł̃vO~O I (SnapLVP ON ł̂݃vO~O\)

#define PWM_period 	0xFF
unsigned int	ad_out;

static void __interrupt()		// Timer1 ɂ銄荞ݏ[`
timer1_isr(void)
{
	RC1 = 1;				// |[gCRC11o͂D荞ݔ̃j^Op

	set_timer1_count_down_ini_num(0x7BF0);
							// ^C}1̃JEg_El̐ݒD
							// ͒llƂăJEg_EsC0Ŋ荞݂𔭐邱ƂƂȂD
	clear_interrupt_flag_of_timer1();
							// ^C}1̊荞݃tO0ɂāC̃^C}1ɂ銄荞݂tƂ

	start_ad_conversion();
	ad_out = read_result_of_ad_conversion();

	set_PWM_duty_cycle(ad_out);	// PWMf[eB̐ݒ

	RC1 = 0;				// |[gCRC10o͂D荞ݔ̃j^Op
}



void main(void)
{
	TRISA = 0x00;			// |[gAo̓|[gɐݒ肷D
	TRISC = 0x04;			// |[gC̓|[gɐݒ肷D

	
	//IV[^̐ݒ
	set_osc(Int_OSC_Freq_8MHz, SysClockSource_detmd_by_Config);
			// IV[^8MHzFOSC=32MHzƐݒ肷D

	//@^C}[1̐ݒ
	set_timer1(TMR1_clock_source_FOSC, T1Clock_PreScale_1_1, TMR1_ON);
			// ^C}P̃NbN\[XCݒ肵āC^C}1IƂD
	set_interrupt_by_timer1();
			// ^C}1ɂ銄荞݂ƂD

	// A/DϊW[̐ݒ
	set_AD_Converter(select_AN6, AD_ON, right_justified, clock_1_32, neg_ref_VSS, pos_ref_FVR);

	// FVR̐ݒ
	set_FVR(FVR_ON, ad_ref_4_096);

	// PWMW[̐ݒ
	set_PWM(Half_Bridge_with_P2A_P2B, P2A_B_C_D_active_high, P2B_to_RA4, P2A_to_RA5, based_on_timer2);

	// ^C}2̐ݒ
	set_timer2(set_Postscaler_1_1, timer2_on, set_Prescaler_1_1, PWM_period);
	
	for(;;)
		continue;		// [v
}
